<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container jumbotron">
        <p class="h3 text-center mt-5">THÔNG TIN LIÊN HỆ CHI TIẾT</p>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label for="">Name <span style="color: red;">(*)</span></label>
            </div>
            <div class="col-4">
                <input type="text" class="form-control" id="inp-name">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label for="">Email <span style="color: red;">(*)</span></label>
            </div>
            <div class="col-4">
                <input type="text" class="form-control" id="inp-email">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label for="">Message <span style="color: red;">(*)</span></label>
            </div>
            <div class="col-4">
                <textarea name="" id="inp-message" cols="43" rows="5"></textarea>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">
                <label for="">Ngày liên hệ <span style="color: red;">(*)</span></label>
            </div>
            <div class="col-4">
                <input type="text" class="form-control" id="inp-date">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-2 text-right">

            </div>
            <div class="col-4 text-right">
                <button class="btn btn-success" onclick="onBtnSaveDataClick()">Save Data</button>
            </div>
        </div>

    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gID;
    var gORDER_CODE;
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    var gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm thực hiện khi load trang
    function onPageLoading() {
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        gID = vUrl.searchParams.get("id");

        //kiểm tra dữ liệu
        const vListContact = "Task 33.20.listContact.html"
        if (gID == null) {
            alert("không có id của đơn hàng");
            window.location.href = vListContact;
        }
        console.log(gID);

        //gọi api lấy thông tin đơn hàng 
        var vXmlHttpContact = new XMLHttpRequest();
        goiApiLayThongTin(vXmlHttpContact, gID)
        vXmlHttpContact.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                showContactInfo(vXmlHttpContact);

            }
        }
    }
    function onBtnSaveDataClick() {
        //khai báo đối tượng
        var vContactObj = {
            name: "",
            email: "",
            message: "",
            createDate: "",
        }
        //B1 Thu thập dữ liệu đưa vào đối tượng
        thuThapDuLieuContact(vContactObj);
        //B2 kiểm tra dữ liệu
        var vDuLieuHopLe = kiemTraDuLieuContact(vContactObj);
        if(vDuLieuHopLe){
            var vXmlHttpContact = new XMLHttpRequest()
            //B3 gọi api cập nhật contact
            goiApiCapNhatContact(vContactObj,vXmlHttpContact,gID);
            vXmlHttpContact.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                xuLyHienThiUpdate(vXmlHttpContact);
            }
        }
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function goiApiLayThongTin(paramXMLHttpContact, paramId) {
        const vAPI_URL = gBASE_URL + "/contacts/";
        paramXMLHttpContact.open("GET", vAPI_URL + paramId, true);
        paramXMLHttpContact.send();
    }
    function showContactInfo(paramXMLHttpContact) {
        console.log(paramXMLHttpContact.responseText);
        var vJsonContactObj = JSON.parse(paramXMLHttpContact.responseText);
        var vInpName = document.getElementById("inp-name");
        var vInpEmail = document.getElementById("inp-email");
        var vInpMessage = document.getElementById("inp-message");
        var vInpDate = document.getElementById("inp-date");

        vInpName.value = vJsonContactObj.name;
        vInpEmail.value = vJsonContactObj.email;
        vInpMessage.value = vJsonContactObj.message;
        vInpDate.value = vJsonContactObj.createDate;
    }
    function thuThapDuLieuContact(paramContactObj) {
        var vInpName = document.getElementById("inp-name");
        var vInpEmail = document.getElementById("inp-email");
        var vInpMessage = document.getElementById("inp-message");
        var vInpDate = document.getElementById("inp-date");
        paramContactObj.name = vInpName.value.trim();
        paramContactObj.email = vInpEmail.value.trim();
        paramContactObj.message = vInpMessage.value.trim();
        paramContactObj.createDate = vInpDate.value.trim();
    }
    function kiemTraDuLieuContact(paramContactObj) {
        if (paramContactObj.name == "") {
            alert("Tên chưa được nhập");
            return false;
        }
        var vRegexEmail = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        if (!paramContactObj.email.match(vRegexEmail)) {
            alert("Email không đúng định dạng");
            return false;
        }
        if(paramContactObj.message.length < 20){
            alert("Message phải lớn hơn 20 kí tự");
            return false;
        }
        if(paramContactObj.createDate == ""){
            alert("Ngày cập nhật chưa nhập");
            return false;
        }
        return true;
    }
    function goiApiCapNhatContact(paramContactObj, paramXmlHttp,paramId){
        const vAPI_URL = gBASE_URL + "/contacts/";
        paramXmlHttp.open("PUT", vAPI_URL + paramId, true);
        paramXmlHttp.setRequestHeader("Content-Type", "application/json");
        paramXmlHttp.send(JSON.stringify(paramContactObj));
    }
    function xuLyHienThiUpdate(paramXmlHttp){
        console.log(paramXmlHttp.responseText);
        alert("Cập nhật thành công");
        window.location.href = "Task 33.20.listContact.html";
    }
</script>

</html>